<template>
  <div>
    <div class="md-layout-item md-medium-size-100 md-xsmall-size-100 md-size-100">
      <md-card class="md-card-plain">
        <md-card-header>
          <label>From</label>
          <datepicker
            format="yyyy-MM-dd"
            v-model="startDate"
            :value="startDate"
            name="startDate"
            :disabledDates="startDisabledDates">
          </datepicker>
          <label>To</label>
          <datepicker
            format="yyyy-MM-dd"
            v-model="endDate"
            :value="endDate"
            name="endDate"
            :disabledDates="endDisabledDates">
          </datepicker>
        </md-card-header>
        <md-card-content>
          <md-table>
             <md-table-row>
                <md-table-cell>Number of registered user</md-table-cell>
                <md-table-cell>{{ registerCount }}</md-table-cell>
              </md-table-row>
             <md-table-row>
                <md-table-cell>Number of KYC user</md-table-cell>
                <md-table-cell>{{ kycCount }}</md-table-cell>
              </md-table-row>
          </md-table>
        </md-card-content>
      </md-card>
    </div>
  </div>
</template>
<script>
import moment from 'moment';

import rf from '../../common/requests/RequestFactory';

export default {
  data () {
    return {
      registerCount: 0,
      kycCount: 0,
      startDate: moment().format('YYYY-MM-DD'),
      endDate: moment().format('YYYY-MM-DD'),
    };
  },
  computed: {
    endDisabledDates () {
      const startDate = moment(this.startDate);
      return {
        to: new Date(startDate.year(), startDate.month(), startDate.date()),
      };
    },
    startDisabledDates () {
      const endDate = moment(this.endDate);
      return {
        from: new Date(endDate.year(), endDate.month(), endDate.date()),
      };
    },
  },
  watch: {
    startDate() {
      this.getUserReport();
    },
    endDate() {
      this.getUserReport();
    },
  },
  methods: {
    async getUserReport () {
      const params = {
        startDate: moment(this.startDate).format('YYYY-MM-DD'),
        endDate: moment(this.endDate).format('YYYY-MM-DD'),
      };
      const result = await rf.getRequest('UserRequest').getUserReport(params);
      this.registerCount = result.data.registerCount;
      this.kycCount = result.data.kycCount;
    }
  },
  created () {
    this.getUserReport();
  },
};
</script>
